﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCWin;
namespace HeadFirst_07_DogRace
{
    public partial class Main : CCSkinMain
    {
        #region 初始化对象，参数，界面信息
        Random random = new Random();
        GreyHound[] Dog = new GreyHound[4];
        PictureBox[] picDog = new PictureBox[4];
        Bet[] bet = new Bet[3];
        Guy[] guyArry = new Guy[3];
        public Main()
        {
            InitializeComponent();
            labMinimumBet.Text = "Minimum bet: " + numUDMoney.Minimum.ToString() + " bucks!";
            picDog[0] = picDog1;
            picDog[1] = picDog2;
            picDog[2] = picDog3;
            picDog[3] = picDog4;
            for (int i = 0; i < 4; i++)
            {
                Dog[i] = new GreyHound(picDog[i]);
                Dog[i].Index = i + 1;
                Dog[i].RacetrackLength = 490;
                Dog[i].randomizer = random;
                Dog[i].TakeStartingPositing();
            }
            guyArry[0] = new Guy() { Name = "Joe", Cash = 50, MyRadioButton = rbtnJoe, MyLabel = labJoe };
            guyArry[1] = new Guy() { Name = "Bob", Cash = 75, MyRadioButton = rbtnBob, MyLabel = labBob };
            guyArry[2] = new Guy() { Name = "Al", Cash = 45, MyRadioButton = rbtntAl, MyLabel = labAl };
            foreach (Guy guy in guyArry)
            {
                guy.UpDateLabel();
            }
        }
        #endregion

        #region  投注
        private void btnBeats_Click(object sender, EventArgs e)
        {
            foreach (Guy guy in guyArry)
            {
                if (guy.MyRadioButton.Checked)
                {
                    guy.PlaceBet((int)numUDMoney.Value, (int)numUDDog.Value);
                    guy.UpDateLabel();
                }
            }
        }
        #endregion

        #region 比赛
        private void btnRace_Click(object sender, EventArgs e)
        {
            btnBeats.Enabled = false;
            bool win = false;
            while (!win)
            {
                foreach (GreyHound dog in Dog)
                {
                    win = dog.Run();
                    if (win)
                    {
                        MessageBox.Show(dog.Index + "号赢得胜利");
                        foreach (Guy guy in guyArry)
                        {
                            guy.Collect(dog.Index);
                            guy.UpDateLabel();
                        }
                        break;      //赢得比赛后退出循环
                    }
                    else
                    {
                        System.Threading.Thread.Sleep(20);
                        Application.DoEvents();
                    }
                }
            }
            foreach (GreyHound dog in Dog)
            {
                //赛狗图片复位
                dog.MyPictureBox.Location = dog.StaringPositing;
            }
            foreach (Guy guy in guyArry)
            {
                //清除赌注对象，并更新信息
                guy.ClearBet();
            }
            btnBeats.Enabled = true;
        }
        #endregion
    }
}
